var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { getClassName } from '@react-devui/utils';
import { useGeneralContext, useDValue } from '../../hooks';
import { cloneHTMLElement, registerComponentMate } from '../../utils';
import { useFormControl } from '../form';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DCheckbox } from './Checkbox';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DCheckbox.Group' });
export function DCheckboxGroup(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dFormControl, dList, dModel, dDisabled = false, dVertical = false, onModelChange } = _a, restProps = __rest(_a, ["dFormControl", "dList", "dModel", "dDisabled", "dVertical", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gDisabled } = useGeneralContext();
    //#endregion
    const formControlInject = useFormControl(dFormControl);
    const [value, changeValue] = useDValue([], dModel, onModelChange, undefined, formControlInject);
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}checkbox-group`, {
            [`${dPrefix}checkbox-group--vertical`]: dVertical,
        }), role: "group" }, { children: dList.map((item, index) => (_jsx(DCheckbox, Object.assign({ dDisabled: item.disabled || disabled, dInputRender: (el) => cloneHTMLElement(el, {
                ['data-form-item-label-for']: index === 0,
            }), dModel: value.includes(item.value), onModelChange: (checked) => {
                changeValue((draft) => {
                    if (checked) {
                        draft.push(item.value);
                    }
                    else {
                        draft.splice(draft.findIndex((v) => v === item.value), 1);
                    }
                });
            } }, { children: item.label }), item.value))) })));
}
