import type { DRefExtra } from '@react-devui/hooks/useRefExtra';
import React from 'react';
import { DDrawerFooter } from './DrawerFooter';
import { DDrawerHeader } from './DrawerHeader';
export interface DDrawerProps extends React.HTMLAttributes<HTMLDivElement> {
    dVisible: boolean;
    dContainer?: DRefExtra | false;
    dPlacement?: 'top' | 'right' | 'bottom' | 'left';
    dWidth?: number | string;
    dHeight?: number | string;
    dZIndex?: number | string;
    dMask?: boolean;
    dMaskClosable?: boolean;
    dEscClosable?: boolean;
    dSkipFirstTransition?: boolean;
    dDestroyAfterClose?: boolean;
    dHeader?: React.ReactElement | string;
    dFooter?: React.ReactElement;
    dChildDrawer?: React.ReactElement;
    onClose?: () => void;
    afterVisibleChange?: (visible: boolean) => void;
}
export interface DDrawerPrivateProps {
    __zIndex?: number | string;
    __onVisibleChange?: (distance: {
        visible: boolean;
        top: number;
        right: number;
        bottom: number;
        left: number;
    }) => void;
}
export declare const DDrawer: {
    (props: DDrawerProps): JSX.Element | null;
    Header: typeof DDrawerHeader;
    Footer: typeof DDrawerFooter;
};
