var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import React, { useMemo, useRef, useState } from 'react';
import { useForkRef, useIsomorphicLayoutEffect } from '@react-devui/hooks';
import { getClassName, isSimpleArrayEqual } from '@react-devui/utils';
import { registerComponentMate } from '../../utils';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DTableEmpty } from './TableEmpty';
import { DTableExpand } from './TableExpand';
import { DTableFilter } from './TableFilter';
import { DTableSearch } from './TableSearch';
import { DTableTd } from './TableTd';
import { DTableTh } from './TableTh';
import { DTableThAction } from './TableThAction';
export const DTableContext = React.createContext(null);
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTable' });
function Table(props, ref) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dBorder = false, dEllipsis = false } = _a, restProps = __rest(_a, ["children", "dBorder", "dEllipsis"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const elRef = useRef(null);
    const combineElRef = useForkRef(elRef, ref);
    //#endregion
    const [fixed, setFixed] = useState([]);
    const getFixed = (el) => {
        const scrollLeft = el.scrollLeft;
        const maxScrollLeft = el.scrollWidth - el.clientWidth;
        let newFixed = [];
        if (maxScrollLeft === 0) {
            newFixed = [];
        }
        else if (scrollLeft === 0) {
            newFixed = ['right'];
        }
        else if (Math.ceil(scrollLeft) >= maxScrollLeft) {
            newFixed = ['left'];
        }
        else {
            newFixed = ['left', 'right'];
        }
        if (!isSimpleArrayEqual(newFixed, fixed)) {
            setFixed(newFixed);
        }
    };
    useIsomorphicLayoutEffect(() => {
        if (elRef.current) {
            getFixed(elRef.current);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const contextValue = useMemo(() => ({
        gFixed: fixed,
        gEllipsis: dEllipsis,
    }), [dEllipsis, fixed]);
    return (_jsx(DTableContext.Provider, Object.assign({ value: contextValue }, { children: _jsx("div", Object.assign({}, restProps, { ref: combineElRef, className: getClassName(restProps.className, `${dPrefix}table`, {
                [`${dPrefix}table--border`]: dBorder,
            }), onScroll: (e) => {
                var _a;
                (_a = restProps.onScroll) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                getFixed(e.currentTarget);
            } }, { children: children })) })));
}
export const DTable = React.forwardRef(Table);
DTable.Th = DTableTh;
DTable.ThAction = DTableThAction;
DTable.Td = DTableTd;
DTable.Empty = DTableEmpty;
DTable.Filter = DTableFilter;
DTable.Search = DTableSearch;
DTable.Expand = DTableExpand;
